-- thanks to moebius92 for quest parsing idea/method

import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "ChallengeTracker.ChallengeTrackerMain.TrackerWindow";
import "ChallengeTracker.ChallengeTrackerMain.Settings";

ChallengeTrackerMain = class();

function ChallengeTrackerMain:Constructor()
	self.settings = ChallengeTracker.ChallengeTrackerMain.Settings();
	self.TrackerWindow = ChallengeTracker.ChallengeTrackerMain.TrackerWindow(self.settings);
end

function ChallengeTrackerMain:WriteToChatByInstance()
	Turbine.Shell.WriteLine("Current Challenge Locks:");
	for i=0, self.settings.settingsTable.instances.length-1 do
		local instance = self.settings.settingsTable.instances:Get(i);
		for j=0, self.settings.settingsTable.players.length-1 do
			local player = self.settings.settingsTable.players:Get(j);
			if(self.settings.settingsTable.locks[instance][player] == true) then
				Turbine.Shell.WriteLine(player.." has "..instance.." lock.");
			end
			if(self.settings.settingsTable.locks[instance][player] == false) then
				Turbine.Shell.WriteLine(player.." doesn't have "..instance.." lock.");
			end
		end
	end
end

function ChallengeTrackerMain:WriteToChatByPlayer()
	local instanceCount = self:GetInstanceCount();
	local playerCount = self:GetPlayerCount();
	Turbine.Shell.WriteLine("Current Challenge Locks:");
	for j=1, playerCount, 1 do
		local player = self:GetPlayer(j);
		for i=1, instanceCount, 1 do
			local instance = self:GetInstance(i);
			if(self:GetLockInfo(instance,player)) then
				Turbine.Shell.WriteLine(player.." has "..instance " lock.");
			end
		end
	end
end

CTM = ChallengeTrackerMain();
function Turbine.Chat.Received(f,args)
	if(args.ChatType == Turbine.ChatType.Quest) then
		local message = args.Message;
		if(string.sub(message,1,10) == "Completed:") then
			if(CTM.settings:Update(message)) then
				CTM.TrackerWindow:refreshCurrentTab();
			end
		end
	end
end

ChallengeTrackerCommand = class(Turbine.ShellCommand);

function ChallengeTrackerCommand:Execute(command,arguments)
	if(string.find(arguments,"show") ~= nil) then
		CTM.TrackerWindow:SetVisible(true);
	elseif(string.find(arguments,"hide") ~= nil) then
		CTM.TrackerWindow:SetVisible(false);
	else
		CTM.TrackerWindow:SetVisible(not CTM.TrackerWindow:IsVisible());
	end
end

function ChallengeTrackerCommand:GetHelp()
	return "Arguments: \nshow - Display the tracker window\nhide - Hide the tracker window\n[none] - Flip the state of the tracker window"; 
end

function ChallengeTrackerCommand:GetShortHelp()
	return "Hide/show the tracker window"; 
end


challengeTrackerCommand = ChallengeTrackerCommand();
Turbine.Shell.AddCommand('ct',challengeTrackerCommand);